package com.ti.mobpo

import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.viewmodel.CreationExtras
import androidx.lifecycle.viewmodel.initializer
import androidx.lifecycle.viewmodel.viewModelFactory
import com.ti.mobpo.ui.viewmodels.FavouritesViewModel
import com.ti.mobpo.ui.viewmodels.PokeSearchViewModel

object AppViewModelProvider {
    val Factory = viewModelFactory {
        initializer {
            PokeSearchViewModel(
                pokesearchApplication().appContainer.favouritesRepository
            )

        }

        initializer {
            FavouritesViewModel(
                pokesearchApplication().appContainer.favouritesRepository, pokesearchApplication().featureManager
            )
        }
    }
}

fun CreationExtras.pokesearchApplication(): PokeSearch =
    (this[ViewModelProvider.AndroidViewModelFactory.APPLICATION_KEY] as PokeSearch)

